dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x,y,angle,scale_x,scale_y = EntityGetTransform(entity_id)

--Also refreshing the structure's physics body if it got unloaded while we're here
local did_hit = RaytracePlatforms(x + 116, y + 70 , x + 116, y + 70)
local did_hit2 = RaytracePlatforms(x + 243, y + 290 , x + 243, y + 290)

if not did_hit or not did_hit2 then
	local physics_body_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")

	EntitySetComponentIsEnabled( entity_id, physics_body_component, false )
	EntitySetComponentIsEnabled( entity_id, physics_body_component, true )
end

--Toggling components on and off depending on tablet count
local tablets_found = tonumber(GlobalsGetValue("cloudmillion_quest_tablets_found", "0"))
if tablets_found == 0 then

	for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
		
		if EntityGetName(child_id) == "shield1" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_hand", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield2" then

			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield3" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield4" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield5" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end

	end
	
elseif tablets_found == 1 then

	for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
		
		if EntityGetName(child_id) == "shield1" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_hand", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield2" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield3" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield4" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield5" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end

	end
	
elseif tablets_found == 2 then

	for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
		
		if EntityGetName(child_id) == "shield1" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_hand", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield2" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield3" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield4" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield5" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end

	end
	
elseif tablets_found == 3 then

	for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
		
		if EntityGetName(child_id) == "shield1" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_hand", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield2" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield3" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield4" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield5" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end

	end
	
elseif tablets_found == 4 then

	for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
		
		if EntityGetName(child_id) == "shield1" then
			
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_hand", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", true )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", true )
			
		end
		
		if EntityGetName(child_id) == "shield2" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield3" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield4" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield5" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end

	end
	
elseif tablets_found >= 5 then

	for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
		
		if EntityGetName(child_id) == "shield1" then
			
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_hand", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield2" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield3" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield4" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end
		
		if EntityGetName(child_id) == "shield5" then
		
			EntitySetComponentsWithTagEnabled( child_id, "enabled_in_world", false )
			EntitySetComponentsWithTagEnabled( child_id, "enabled_while_shielding", false )
			
		end

	end
	
end