function spawn_small_enemies(x, y, w, h, is_open_path)
	if( is_open_path ) then
		local r = ProceduralRandom( x, y )
		local spawn_percent = BiomeMapGetVerticalPositionInsideBiome( x, y )
		spawn_percent = ( 2.1 * spawn_percent ) + 0.2
		if( r > spawn_percent ) then return end
		spawn_with_limited_random(g_small_enemies,x,y,0,0,{"longleg","fungus"})
		--spawn_hp(g_small_enemies,x,y,0,0,0.4,"coalmines")
		EntityLoad( "mods/cloudmillion_quest/files/spawners/hiisi_spawner.xml", x, y)
	else
		spawn_with_limited_random(g_small_enemies,x,y,0,0,{"longleg","fungus"})
		EntityLoad( "mods/cloudmillion_quest/files/spawners/hiisi_spawner.xml", x, y)
		--spawn_hp(g_small_enemies,x,y,0,0,0.4,"coalmines")
	end
end

function spawn_big_enemies(x, y, w, h, is_open_path)
	if( is_open_path ) then
		local r = ProceduralRandom( x, y )
		local spawn_percent = BiomeMapGetVerticalPositionInsideBiome( x, y )
		spawn_percent = ( 1.75 * spawn_percent ) - 0.1
		if( r > spawn_percent ) then return end
		spawn_with_limited_random(g_big_enemies,x,y,0,0,{"longleg","fungus"})
		EntityLoad( "mods/cloudmillion_quest/files/spawners/hiisi_spawner.xml", x, y)
		--spawn_hp(g_big_enemies,x,y,0,0,0.4,"coalmines")
	else
		spawn_with_limited_random(g_big_enemies,x,y,0,0,{"longleg","fungus"})
		EntityLoad( "mods/cloudmillion_quest/files/spawners/hiisi_spawner.xml", x, y)
		--spawn_hp(g_big_enemies,x,y,0,0,0.4,"coalmines")
	end
end

function spawn_vines(x, y)
	spawn(g_vines,x+5,y+5)
	EntityLoad( "mods/cloudmillion_quest/files/spawners/ceiling_trap_spawner.xml", x+5, y+5)
end