RegisterSpawnFunction( 0xffd1d719, "spawn_shopkeeper" )

function spawn_shopkeeper(x, y)
	EntityLoad("mods/cloudmillion_quest/files/shopkeeper/shopkeeper.xml", x, y)
	EntityLoad("mods/cloudmillion_quest/files/shopkeeper/table.xml", x, y)
end

function init(x, y, w, h)
	-- the pixel scene spawns to left or right by random
	is_right = ProceduralRandom(0,0) > 0.5

	-- don't spawn when looping around world to avoid incorrect placement
	if x > 10000 or x < -10000 then return end

	if is_right and x > 0 then
		LoadPixelScene( "data/biome_impl/snowcastle/side_cavern_right.png", "data/biome_impl/snowcastle/side_cavern_right_visual.png", x-50, y, "data/biome_impl/snowcastle/side_cavern_right_background.png", true )
	elseif not is_right and x < 0 then
		LoadPixelScene( "data/biome_impl/snowcastle/side_cavern_left.png", "data/biome_impl/snowcastle/side_cavern_left_visual.png", x+50, y, "data/biome_impl/snowcastle/side_cavern_left_background.png", true )
	end
end

function spawn_shopkeeper(x, y)
	if is_right then
		local hiisi = EntityLoad("mods/cloudmillion_quest/files/shopkeeper/shopkeeper.xml", x, y)
		EntityLoad("mods/cloudmillion_quest/files/shopkeeper/table.xml", x, y)
		local hx, hy, rot, scale_x  = EntityGetTransform(hiisi)
		EntitySetTransform(hiisi, hx, hy, rot, -1)
	else
		local hiisi = EntityLoad("mods/cloudmillion_quest/files/shopkeeper/shopkeeper.xml", x, y)
		EntityLoad("mods/cloudmillion_quest/files/shopkeeper/table.xml", x, y)
	end
end