dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )
local player = EntityGetInRadiusWithTag( pos_x, pos_y, 20, "player_unit" )

if #player > 0 then
	
	-- if (GlobalsGetValue("cloudmillion_quest_tablet1_found") == "1") then 
		-- return
	-- end
	
	--Particles
	-- EntityLoad("data/entities/particles/gold_pickup_huge.xml", tablet_x, tablet_y )
	
	--Audio
	-- GameTriggerMusicFadeOutAndDequeueAll( 3.0 )
	-- GameTriggerMusicEvent( "music/oneshot/dark_01", true, pos_x, pos_y )
	GamePlaySound( "data/audio/Desktop/misc.snd", "misc/chest_dark_open", pos_x, pos_y )
	
	GameTriggerMusicFadeOutAndDequeueAll( 3.0 )
	GameTriggerMusicEvent( "music/oneshot/dark_02", true, pos_x, pos_y )
	
	--Adding world conversion activation to the tablet if it's picked up
	-- GlobalsSetValue("cloudmillion_quest_tablet1_found", "1")

	local tablets_found = tonumber(GlobalsGetValue("cloudmillion_quest_tablets_found", "0"))

	--Here im setting the amount of tablets found to the current amount + 1 cause we just picked up ruby tablet 1
	GlobalsSetValue("cloudmillion_quest_tablets_found", tablets_found + 1)
	
	local tablets_found_updated = tonumber(GlobalsGetValue("cloudmillion_quest_tablets_found", "0"))
	
	if tablets_found_updated == 3 then
		EntityAddComponent2(player[1], "LuaComponent", {
			execute_every_n_frame=60,
			script_source_file="mods/cloudmillion_quest/files/spawners/hiisi_hunter_spawner_spawner.lua" 
		})
	end
	
	EntityRemoveComponent(entity_id, GetUpdatedComponentID())
end