function item_pickup(entity_item, entity_pickupper, item_name)
  local inventory = find_inventory_entity(entity_pickupper)
  local item_component = EntityGetFirstComponentIncludingDisabled( entity_item, "ItemComponent" )
  local tablet_desc = ComponentGetValue2( item_component, "item_name" )
  if tablet_desc == "$ruby_tablet_name1" then
	tablet_physics = EntityLoad("mods/cloudmillion_quest/files/tablets/tablet1_physics.xml")
  elseif tablet_desc == "$ruby_tablet_name2" then
	tablet_physics = EntityLoad("mods/cloudmillion_quest/files/tablets/tablet2_physics.xml")
  elseif tablet_desc == "$ruby_tablet_name3" then
	tablet_physics = EntityLoad("mods/cloudmillion_quest/files/tablets/tablet3_physics.xml")
  elseif tablet_desc == "$ruby_tablet_name4" then
	tablet_physics = EntityLoad("mods/cloudmillion_quest/files/tablets/tablet4_physics.xml")
  elseif tablet_desc == "$ruby_tablet_name5" then
	tablet_physics = EntityLoad("mods/cloudmillion_quest/files/tablets/tablet5_physics.xml")
  end
  EntityKill(entity_item)
  EntityAddChild(inventory, tablet_physics)
  EntitySetComponentsWithTagEnabled(tablet_physics, "enabled_in_world", false)

  -- local inventory2_comp = EntityGetFirstComponentIncludingDisabled(entity_pickupper, "Inventory2Component")
  -- if( inventory2_comp ) then
  --   ComponentSetValue( inventory2_comp, "mActualActiveItem", "0" )
  -- end

  local x, y = EntityGetTransform(entity_item)
end

function find_inventory_entity(entity_id)
  for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
    if EntityGetName(child) == "inventory_quick" then
      return child
    end
  end
end
