dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x,y,angle,scale_x,scale_y = EntityGetTransform(entity_id)

--Also refreshing the structure's physics body if it got unloaded while we're here
local did_hit = RaytracePlatforms(x, y , x, y)

if not did_hit then
	local physics_body_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")

	EntitySetComponentIsEnabled( entity_id, physics_body_component, false )
	EntitySetComponentIsEnabled( entity_id, physics_body_component, true )
end

function physics_body_modified( is_destroyed )
	local entity_id = GetUpdatedEntityID()
	local physics_body_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")

	EntitySetComponentIsEnabled( entity_id, physics_body_component, false )
	EntitySetComponentIsEnabled( entity_id, physics_body_component, true )
end