dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "shield_radius")

local radius = ComponentGetValue2(var_comp, "value_float")

local projectiles = EntityGetInRadiusWithTag( x, y, 190, "rainbow_trail" )
if ( #projectiles > 0 ) then
	for i,projectile_id in ipairs(projectiles) do	
		EntityKill(projectile_id)
		local px, py = EntityGetTransform( projectile_id )
		EntityLoad("data/entities/buildings/wizardcave_gate_egg_fx.xml", px, py)
		EntityLoad("mods/cloudmillion_quest/files/armageddon_machine/magical_symbol_small.xml", px, py)
		GamePlaySound( "data/audio/Desktop/projectiles.bank", "projectiles/magic/create", px, py )
	end
end