function spawn_small_enemies(x, y)
	EntityLoad( "mods/cloudmillion_quest/files/spawners/hiisi_spawner.xml", x, y)
	local r = ProceduralRandom( x, y )
	local spawn_percent = BiomeMapGetVerticalPositionInsideBiome( x, y )
	spawn_percent = ( 2.5 * spawn_percent ) + 0.35
	if( r > spawn_percent ) then return end

	spawn(g_small_enemies,x,y)
end

function spawn_big_enemies(x, y)
	EntityLoad( "mods/cloudmillion_quest/files/spawners/hiisi_spawner_harder.xml", x, y)
	local r = ProceduralRandom( x, y )
	local spawn_percent = BiomeMapGetVerticalPositionInsideBiome( x, y )
	spawn_percent = ( 2.1 * spawn_percent )
	if( r > spawn_percent ) then return end

	spawn(g_big_enemies,x,y)
end

function spawn_lamp(x, y)
	spawn(g_lamp,x,y+2,0,0)
	SetRandomSeed( x, y )
	local random_value = Random(1,4)
	if random_value == 1 then
		EntityLoad( "mods/cloudmillion_quest/files/spawners/ceiling_trap_spawner.xml", x+5, y+5)
	elseif random_value == 2 then
		EntityLoad( "mods/cloudmillion_quest/files/spawners/ceiling_beam_trap_spawner.xml", x+5, y+5)
	end
end