local tablets_found = tonumber(GlobalsGetValue("cloudmillion_quest_tablets_found", "0"))
local ending = tonumber(GlobalsGetValue("cloudmillion_quest_ending_triggered", "0"))
if ending ~= 1 then
	if tablets_found == 3 then
	  local entity_id = GetUpdatedEntityID()
	  local x, y = EntityGetTransform(entity_id)
	  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	  
	  local creatures = {}
	  
	  table.insert(creatures, "data/entities/animals/shotgunner.xml")
	  table.insert(creatures, "data/entities/animals/scavenger_mine.xml")
	  table.insert(creatures, "data/entities/animals/scavenger_smg.xml")
	  table.insert(creatures, "data/entities/animals/scavenger_grenade.xml")
	  
	  local random_index = Random(1, #creatures)
	  local creature = creatures[random_index]
	  
	  local players = EntityGetInRadiusWithTag( x, y, 300, "player_unit" )
	  if Random(1, 2) == 1 and ( #players < 1 ) then
		local creature = EntityLoad(creature, x, y)
		EntityKill(entity_id)
	  end
	elseif tablets_found == 4 then
	  local entity_id = GetUpdatedEntityID()
	  local x, y = EntityGetTransform(entity_id)
	  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	  
	  local creatures = {}
	  
	  table.insert(creatures, "data/entities/animals/rainforest/scavenger_clusterbomb.xml")
	  table.insert(creatures, "data/entities/animals/rainforest/scavenger_mine.xml")
	  table.insert(creatures, "data/entities/animals/rainforest/scavenger_leader.xml")
	  table.insert(creatures, "data/entities/animals/rainforest/flamer.xml")
	  
	  local random_index = Random(1, #creatures)
	  local creature = creatures[random_index]
	  
	  local players = EntityGetInRadiusWithTag( x, y, 300, "player_unit" )
	  if Random(1, 2) == 1 and ( #players < 1 ) then
		local creature = EntityLoad(creature, x, y)
		EntityKill(entity_id)
	  end
	elseif tablets_found >= 5 then
	  local entity_id = GetUpdatedEntityID()
	  local x, y = EntityGetTransform(entity_id)
	  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	  
	  local creatures = {}
	 
	  table.insert(creatures, "data/entities/animals/vault/scavenger_leader.xml")
	  table.insert(creatures, "data/entities/animals/vault/flamer.xml")
	  table.insert(creatures, "data/entities/animals/vault/icer.xml")
	  table.insert(creatures, "data/entities/animals/rainforest/scavenger_poison.xml")
	  table.insert(creatures, "data/entities/animals/vault/assassin.xml")
	  table.insert(creatures, "data/entities/animals/spearbot.xml")
	  
	  local random_index = Random(1, #creatures)
	  local creature = creatures[random_index]
	  
	  local players = EntityGetInRadiusWithTag( x, y, 300, "player_unit" )
	  if Random(1, 2) == 1 and ( #players < 1 ) then
		local creature = EntityLoad(creature, x, y)
		EntityKill(entity_id)
	  end
	end
end
