local tablets_found = tonumber(GlobalsGetValue("cloudmillion_quest_tablets_found", "0"))
if tablets_found == 3 then
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  
	local found, nx, ny, apd = GetSurfaceNormal(x, y, 10, 16)
	if found then
	  nx = nx * (math.abs(apd) + 2)
	  ny = ny * (math.abs(apd) + 2)
	else
	  nx = 0
	  ny = 0
	end

	local entities = EntityGetInRadiusWithTag( x, y, 300, "hiisi_hunter_spawner" )

	if ( #entities < 1 ) then
	  local did_hit, hit_x, hit_y = RaytraceSurfaces(x - nx, y - ny, x - nx, y - ny)
	  
	  if not did_hit then
		EntityLoad( "mods/cloudmillion_quest/files/spawners/hiisi_hunter_spawner.xml", x - nx, y - ny )
	  end
	  
	end
	
elseif tablets_found >= 4 then

  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  
	local found, nx, ny, apd = GetSurfaceNormal(x, y, 10, 16)
	if found then
	  nx = nx * (math.abs(apd) + 2)
	  ny = ny * (math.abs(apd) + 2)
	else
	  nx = 0
	  ny = 0
	end

	local entities = EntityGetInRadiusWithTag( x, y, 150, "hiisi_hunter_spawner" )

	if ( #entities < 1 ) then
	  local did_hit, hit_x, hit_y = RaytraceSurfaces(x - nx, y - ny, x - nx, y - ny)
	  
	  if not did_hit then
		EntityLoad( "mods/cloudmillion_quest/files/spawners/hiisi_hunter_spawner.xml", x - nx, y - ny )
	  end
	end
end
