local tablets_found = tonumber(GlobalsGetValue("cloudmillion_quest_tablets_found", "0"))
if tablets_found == 1 then
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
  local creatures = {}
  
  table.insert(creatures, "data/entities/animals/miner.xml")
  table.insert(creatures, "data/entities/animals/shotgunner.xml")
  table.insert(creatures, "data/entities/animals/sniper.xml")
  table.insert(creatures, "data/entities/animals/scavenger_smg.xml")
  table.insert(creatures, "data/entities/animals/scavenger_grenade.xml")
  
  local random_index = Random(1, #creatures)
  local creature = creatures[random_index]
  EntityLoad(creature, x, y)
elseif tablets_found == 2 then
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	for i=1, Random(1,2) do
	  local creatures = {}
	  
	  table.insert(creatures, "data/entities/animals/scavenger_leader.xml")
	  table.insert(creatures, "data/entities/animals/scavenger_poison.xml")
	  table.insert(creatures, "data/entities/animals/scavenger_smg.xml")
	  table.insert(creatures, "data/entities/animals/scavenger_grenade.xml")
	  
	  local random_index = Random(1, #creatures)
	  local creature = creatures[random_index]
	  EntityLoad(creature, x, y)
	end
elseif tablets_found == 3 then
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	for i=1, Random(1,3) do
	  local creatures = {}
	  
	  table.insert(creatures, "data/entities/animals/scavenger_leader.xml")
	  table.insert(creatures, "data/entities/animals/scavenger_clusterbomb.xml")
	  table.insert(creatures, "data/entities/animals/rainforest/flamer.xml")
	  table.insert(creatures, "data/entities/animals/spearbot.xml")
	  
	  local random_index = Random(1, #creatures)
	  local creature = creatures[random_index]
	  EntityLoad(creature, x, y)
	end
elseif tablets_found == 4 then
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	for i=1, Random(3,5) do
	  local creatures = {}
	  
	  table.insert(creatures, "data/entities/animals/vault/scavenger_leader.xml")
	  table.insert(creatures, "data/entities/animals/rainforest/scavenger_clusterbomb.xml")
	  table.insert(creatures, "data/entities/animals/vault/icer.xml")
	  table.insert(creatures, "data/entities/animals/vault/assassin.xml")
	  table.insert(creatures, "data/entities/animals/vault/flamer.xml")
	  table.insert(creatures, "data/entities/animals/spearbot.xml")
	  
	  local random_index = Random(1, #creatures)
	  local creature = creatures[random_index]
	  EntityLoad(creature, x, y)
	end
elseif tablets_found >= 5 then
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	for i=1, Random(4,8) do
	  local creatures = {}
	  
	  table.insert(creatures, "data/entities/animals/vault/scavenger_leader.xml")
	  table.insert(creatures, "data/entities/animals/rainforest/scavenger_clusterbomb.xml")
	  table.insert(creatures, "data/entities/animals/vault/tank_rocket.xml")
	  table.insert(creatures, "data/entities/animals/vault/tank.xml")
	  table.insert(creatures, "data/entities/animals/vault/missilecrab.xml")
	  table.insert(creatures, "data/entities/animals/vault/icer.xml")
	  table.insert(creatures, "data/entities/animals/vault/assassin.xml")
	  table.insert(creatures, "data/entities/animals/vault/flamer.xml")
	  table.insert(creatures, "data/entities/animals/spearbot.xml")
	  
	  local random_index = Random(1, #creatures)
	  local creature = creatures[random_index]
	  EntityLoad(creature, x, y)
	end
end
