local tablets_found = tonumber(GlobalsGetValue("cloudmillion_quest_tablets_found", "0"))
if tablets_found == 1 then
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
  
  local creatures = {}
  
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_mine.xml")
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_poison.xml")
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_leader.xml")
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_clusterbomb.xml")
  table.insert(creatures, "data/entities/animals/rainforest/coward.xml")
  table.insert(creatures, "data/entities/animals/rainforest/sniper.xml")
  table.insert(creatures, "data/entities/animals/rainforest/flamer.xml")
  
  local random_index = Random(1, #creatures)
  local creature = creatures[random_index]
  local entities = EntityGetInRadiusWithTag( x, y, 100, "pitcheck_b" )
  
  if Random(1, 8) == 1 and not (#entities > 0) then
	local creature = EntityLoad(creature, x, y)
	EntityAddTag( creature, "pitcheck_b" )
  end
  
elseif tablets_found == 2 then

  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
  
  local creatures = {}
  
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_mine.xml")
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_poison.xml")
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_leader.xml")
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_clusterbomb.xml")
  table.insert(creatures, "data/entities/animals/rainforest/coward.xml")
  table.insert(creatures, "data/entities/animals/rainforest/sniper.xml")
  table.insert(creatures, "data/entities/animals/rainforest/flamer.xml")
  
  local random_index = Random(1, #creatures)
  local creature = creatures[random_index]
  local entities = EntityGetInRadiusWithTag( x, y, 100, "pitcheck_b" )
  
  if Random(1, 6) == 1 and not (#entities > 0) then
	local creature = EntityLoad(creature, x, y)
	EntityAddTag( creature, "pitcheck_b" )
  end
  
elseif tablets_found >= 3 then

  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
  
  local creatures = {}
  
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_mine.xml")
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_poison.xml")
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_leader.xml")
  table.insert(creatures, "data/entities/animals/rainforest/scavenger_clusterbomb.xml")
  table.insert(creatures, "data/entities/animals/rainforest/coward.xml")
  table.insert(creatures, "data/entities/animals/rainforest/sniper.xml")
  table.insert(creatures, "data/entities/animals/rainforest/flamer.xml")
  
  local random_index = Random(1, #creatures)
  local creature = creatures[random_index]
  local entities = EntityGetInRadiusWithTag( x, y, 100, "pitcheck_b" )
  
  if Random(1, 4) == 1 and not (#entities > 0) then
	local creature = EntityLoad(creature, x, y)
	EntityAddTag( creature, "pitcheck_b" )
  end
  
end
