dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
local ability_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AbilityComponent")

local child_found = false

for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
	
	local item_comp_id = EntityGetFirstComponentIncludingDisabled( child_id, "ItemActionComponent")
	
	if ComponentGetValue2( item_comp_id, "action_id" ) == "RAINBOW_TRAIL" then
	
		child_found = true
		
		if ComponentGetValue2(sprite_component, "image_file") ~= "mods/cloudmillion_quest/files/wands/experimental_wand_1_sprite_rainbow.xml" then
			 ComponentSetValue2(sprite_component, "image_file", "mods/cloudmillion_quest/files/wands/experimental_wand_1_sprite_rainbow.xml")
			 ComponentSetValue2(ability_component, "sprite_file", "mods/cloudmillion_quest/files/wands/experimental_wand_1_sprite_rainbow.xml")
		end
		
	elseif ComponentGetValue2( item_comp_id, "action_id" ) == "MIST_BLOOD"
	or ComponentGetValue2( item_comp_id, "action_id" ) == "MATERIAL_BLOOD"
	or ComponentGetValue2( item_comp_id, "action_id" ) == "TOUCH_BLOOD"
	or ComponentGetValue2( item_comp_id, "action_id" ) == "BLOOD_MAGIC"
	or ComponentGetValue2( item_comp_id, "action_id" ) == "BLOOD_TO_POWER"
	or ComponentGetValue2( item_comp_id, "action_id" ) == "BLOODLUST"
	or ComponentGetValue2( item_comp_id, "action_id" ) == "CLOUD_BLOOD" then
	
		child_found = true
		
		if ComponentGetValue2(sprite_component, "image_file") ~= "mods/cloudmillion_quest/files/wands/experimental_wand_1_sprite_blood.xml" then
			 ComponentSetValue2(sprite_component, "image_file", "mods/cloudmillion_quest/files/wands/experimental_wand_1_sprite_blood.xml")
			 ComponentSetValue2(ability_component, "sprite_file", "mods/cloudmillion_quest/files/wands/experimental_wand_1_sprite_blood.xml")
		end
		
	end

end

if child_found == false then

	if ComponentGetValue2(sprite_component, "image_file") ~= "mods/cloudmillion_quest/files/wands/experimental_wand_1_sprite.xml" then
		 ComponentSetValue2(sprite_component, "image_file", "mods/cloudmillion_quest/files/wands/experimental_wand_1_sprite.xml")
		 ComponentSetValue2(ability_component, "sprite_file", "mods/cloudmillion_quest/files/wands/experimental_wand_1_sprite.xml")
	end
		
end